Require Import ReflParam.common.
Require Import ReflParam.templateCoqMisc.
Require Import String.
Require Import List.
Require Import Template.Ast.
Require Import SquiggleEq.terms.
Require Import ReflParam.paramDirect ReflParam.indType.
Require Import SquiggleEq.substitution.
Require Import ReflParam.PiTypeR.
Import ListNotations.
Open Scope string_scope.

Variable A : Prop.
Variable B : Prop.

Variable Top_B_pmtcty_RR : B -> B -> Prop.
Definition Top_A_pmtcty_RR := fun (a1 : A) (a2 : A) => a1 = a2.

Definition cpsT := forall (α:Prop), (B -> α) -> α.

Run TemplateProgram (genParam [] false true "cpsT").

Definition id := fun (x : B) => x.

Definition kT := (B -> A).

Run TemplateProgram (genParam [] false true "kT").

(* Note that by the fundamental property, the premises are trivially satisfied, but the translation
   really wants an honest-to-goodness term and not a variable. *)
Theorem Cont_Shuffle : forall e k, (cpsT_pmtcty_RR e e) -> (kT_pmtcty_RR k k) -> (Top_A_pmtcty_RR (e A k) (k (e B id))).
Proof.
  intros e k P_e P_k.
  unfold cpsT_pmtcty_RR in P_e.
  (* The only clever part: instantiate the relation between types A and B to be that a is related to
     (k b) in the A relation*)
  set (P := (P_e A B (fun (a:A) (b:B) => (Top_A_pmtcty_RR a (k b))) k id)).
  unfold id in P at 1.

  exact (P (fun b₁ b₂ H0 => (P_k b₁ b₂ H0))).
Qed.